import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["title", "size", "btnText", "btnType", "filterItems", "columns", "getTableData", "initialValues", "btnDisabled", "children", "itemWidth", "buttons", "rowSelection", "rowKey", "pagination", "onClose", "onSubmit", "onOpen", "onTableInit"];
import React, { useState, useEffect } from 'react';
import styles from "./index.module.less";
import { Modal, Spin, Button } from 'antd';
import { isFunction } from "../../utils";
import YwFilter from "../YwFilter/index";
import YwTable from "../YwTable/index";
var widthMap = {
  s: 680,
  m: 920,
  l: 1200,
  full: '100vw'
};

var YwTableDialog = function YwTableDialog(_ref) {
  var title = _ref.title,
      size = _ref.size,
      btnText = _ref.btnText,
      btnType = _ref.btnType,
      filterItems = _ref.filterItems,
      columns = _ref.columns,
      getTableData = _ref.getTableData,
      initialValues = _ref.initialValues,
      btnDisabled = _ref.btnDisabled,
      children = _ref.children,
      itemWidth = _ref.itemWidth,
      buttons = _ref.buttons,
      rowSelection = _ref.rowSelection,
      rowKey = _ref.rowKey,
      pagination = _ref.pagination,
      onClose = _ref.onClose,
      onSubmit = _ref.onSubmit,
      onOpen = _ref.onOpen,
      onTableInit = _ref.onTableInit,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(others.visible || false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = useState(false),
      spinning = _useState2[0],
      setSpinning = _useState2[1];

  var _useState3 = useState(initialValues),
      filterProps = _useState3[0],
      setFilterProps = _useState3[1];

  var showModal = function showModal() {
    if (isFunction(onOpen)) {
      setSpinning(true);
      onOpen().then(function (initialValues) {})["finally"](function () {
        setSpinning(false);
      });
    }
  };

  var handleCancel = function handleCancel() {
    onClose();
  }; //   const handleOk = () => {
  //     onConfirm(value).finally(() => {
  //       setVisible(false);
  //     });
  //   };


  useEffect(function () {
    setVisible(others.visible);
  }, [others.visible]);
  useEffect(function () {
    if (visible) {
      showModal();
    } else {
      handleCancel();
    }
  }, [visible]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, others.visible === undefined && /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/React.createElement(Button, {
    type: btnType,
    disabled: btnDisabled
  }, btnText)), /*#__PURE__*/React.createElement(Modal, {
    wrapClassName: styles['yw-table-dialog'],
    title: title,
    destroyOnClose: true,
    width: widthMap[size],
    visible: visible // onOk={handleOk}
    ,
    okText: "\u786E\u5B9A",
    onCancel: function onCancel() {
      setVisible(false);
    },
    footer: [/*#__PURE__*/React.createElement(Button, {
      key: "back",
      onClick: function onClick() {
        setVisible(false);
      }
    }, "\u5173\u95ED")]
  }, /*#__PURE__*/React.createElement(Spin, {
    spinning: spinning
  }, /*#__PURE__*/React.createElement(React.Fragment, null, filterItems && /*#__PURE__*/React.createElement(YwFilter, {
    items: filterItems,
    itemWidth: itemWidth,
    initialValues: initialValues // onSubmit={setFilterProps}
    // hasSearchBtn={false}
    ,
    onSubmit: function onSubmit(data) {
      setFilterProps(_extends({}, data));
    },
    maxColumns: 2
  }), /*#__PURE__*/React.createElement(YwTable, {
    filterProps: filterProps,
    ref: function ref(_ref2) {
      _ref2 && isFunction(onTableInit) && onTableInit(_ref2);
    },
    columns: columns,
    rowKey: rowKey,
    getTableData: getTableData,
    buttons: buttons,
    rowSelection: rowSelection,
    pagination: pagination
  })))));
};

YwTableDialog.defaultProps = {
  btnType: 'primary',
  size: 'm',
  btnDisabled: false,
  rowKey: 'id',
  rowSelection: null,
  pagination: {},
  buttons: [],
  onClose: function onClose() {},
  onSubmit: function onSubmit() {}
};
export default YwTableDialog;