import * as React from 'react';
import { InfoCircleFilled, CheckCircleFilled, ExclamationCircleFilled, CloseCircleFilled, QuestionCircleFilled } from '@ant-design/icons';
export var isFunction = function isFunction(value) {
  return typeof value === 'function';
};
export var isObject = function isObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
};
export var isArray = function isArray(arr) {
  return Object.prototype.toString.call(arr) === '[object Array]';
};
export var COLORMAP = {
  primary: '#1890FF',
  success: '#23CBB7',
  error: '#F15A5A',
  warning: '#FAAD14',
  info: '#999',
  other: '#9C7AFF',
  "default": '#999'
};
export var isVisible = function isVisible(visible, data) {
  if (visible === void 0) {
    visible = true;
  }

  return isFunction(visible) ? visible(data) : visible;
};
export var isDisabled = function isDisabled(disabled, data) {
  return isFunction(disabled) ? disabled(data) : disabled;
};
export var StatusTypeIcon = {
  success: /*#__PURE__*/React.createElement(CheckCircleFilled, null),
  warning: /*#__PURE__*/React.createElement(ExclamationCircleFilled, null),
  error: /*#__PURE__*/React.createElement(CloseCircleFilled, null),
  help: /*#__PURE__*/React.createElement(QuestionCircleFilled, null),
  notice: /*#__PURE__*/React.createElement(InfoCircleFilled, null)
};