"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _antd = require("antd");

var _core = require("@formily/core");

var _YwJsonForm = require("../YwJsonForm");

var _utils = require("../../utils");

var _excluded = ["title", "size", "btnText", "btnType", "items", "disabled", "editable", "initialValues", "layoutProps", "btnDisabled", "children", "onCancel", "onConfirm", "onOpen"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var widthMap = {
  s: 680,
  m: 920,
  l: 1200,
  full: '100vw'
};

var YwFormDialog = function YwFormDialog(_ref) {
  var title = _ref.title,
      size = _ref.size,
      btnText = _ref.btnText,
      btnType = _ref.btnType,
      items = _ref.items,
      disabled = _ref.disabled,
      editable = _ref.editable,
      initialValues = _ref.initialValues,
      layoutProps = _ref.layoutProps,
      btnDisabled = _ref.btnDisabled,
      children = _ref.children,
      onCancel = _ref.onCancel,
      onConfirm = _ref.onConfirm,
      onOpen = _ref.onOpen,
      others = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useState = (0, _react.useState)(others.visible || false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      spinning = _useState2[0],
      setSpinning = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      confirmLoading = _useState3[0],
      setConfirmLoading = _useState3[1];

  var form = (0, _react.useMemo)(function () {
    return visible ? (0, _core.createForm)({
      disabled: disabled,
      editable: editable,
      initialValues: initialValues,
      effects: function effects(form) {}
    }) : null;
  }, [visible]);

  var showModal = function showModal() {
    if ((0, _utils.isFunction)(onOpen)) {
      setSpinning(true);
      onOpen().then(function (initialValues) {
        form.setValues(initialValues);
      })["finally"](function () {
        setSpinning(false);
      });
    }
  };

  var handleOk = function handleOk() {
    form.submit().then(function (value) {
      setConfirmLoading(true);
      onConfirm(value).then(function () {
        setVisible(false);
      })["finally"](function () {
        setConfirmLoading(false);
      });
    });
  };

  var handleCancel = function handleCancel() {
    onCancel();
    setConfirmLoading(false);
  };

  (0, _react.useEffect)(function () {
    setVisible(others.visible);
  }, [others.visible]);
  (0, _react.useEffect)(function () {
    if (visible) {
      showModal();
    } else {
      handleCancel();
    }
  }, [visible]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, others.visible === undefined && /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/_react["default"].createElement(_antd.Button, {
    type: btnType,
    disabled: btnDisabled
  }, btnText)), /*#__PURE__*/_react["default"].createElement(_antd.Modal, {
    wrapClassName: _indexModule["default"]['yw-form-dialog'],
    title: title,
    width: widthMap[size],
    visible: visible,
    onOk: handleOk,
    destroyOnClose: true,
    okText: "\u786E\u5B9A" // cancelText={editable ? '取消' : '关闭'}
    ,
    confirmLoading: confirmLoading,
    onCancel: function onCancel() {
      setVisible(false);
    },
    footer: [/*#__PURE__*/_react["default"].createElement(_antd.Button, {
      key: "back",
      onClick: function onClick() {
        setVisible(false);
      }
    }, editable ? '取消' : '关闭'), editable ? [/*#__PURE__*/_react["default"].createElement(_antd.Button, {
      key: "submit",
      type: "primary",
      loading: confirmLoading,
      onClick: handleOk
    }, "\u786E\u5B9A")] : []]
  }, /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
    spinning: spinning
  }, visible && /*#__PURE__*/_react["default"].createElement(_YwJsonForm.YwJsonForm, {
    items: items,
    form: form,
    layoutProps: layoutProps,
    buttons: []
  }))));
};

YwFormDialog.defaultProps = {
  btnType: 'primary',
  size: 's',
  btnDisabled: false,
  editable: true,
  onCancel: function onCancel() {},
  onConfirm: function onConfirm() {}
};
var _default = YwFormDialog;
exports["default"] = _default;